﻿/*
 * This file is part of AV Orchid.
 * Copyright (c) 2013, Dmitri R. Kuvshinov <evetro.here@gmail.com>
 * 
 * Permission to use, copy, modify, and/or distribute this software for
 * any purpose with or without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all copies.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
/**
 * @file DemoGameScreen.hpp
 *
 * Базовый класс (для ввода имени игрока и экрана с лучшими результатами) с "демонстрацией" игры.
 */
#pragma once
#include "GameScreen.hpp"
#include <avo/Color.hpp>

/// базовый класс, реализующий демонстрацию игры
class DemoGameScreen: public GameScreen
{
protected:
  typedef GameScreen Base;
  void onIdle() override;
  void onDisplay() override;

  /// нарисовать полупрозрачный прямоугольник в ширину игрового экрана с заданным покрытием по вертикали
  static void greyRect(float bottom, float top);
  /// случайный цвет
  static avo::Color random_color();
};
