﻿/*
 * This file is part of AV Orchid.
 * Copyright (c) 2013, Dmitri R. Kuvshinov <evetro.here@gmail.com>
 * 
 * Permission to use, copy, modify, and/or distribute this software for
 * any purpose with or without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all copies.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
/**
 * @file EnterNameScreen.cpp
 *
 * Реализация EnterNameScreen.hpp.
 */
#include "EnterNameScreen.hpp"


void EnterNameScreen::onDisplay()
{
  Base::onDisplay();

  float top = 0.8f, bottom = top - 0.09f;
  // приглашение
  greyRect(bottom, top);
  avo::WHITE.select();
  drawString (GLUT_STROKE_ROMAN, "Your score:", 0.2f, bottom, 0.8f, top);
  
  // очки
  greyRect(bottom -= 0.1f, top -= 0.1f);
  random_color().bright().select();
  drawString (GLUT_STROKE_MONO_ROMAN, score, 0.4f, bottom, 0.7f, top);

  greyRect(bottom -= 0.1f, top -= 0.1f);
  avo::YELLOW.select();
  drawString (GLUT_STROKE_ROMAN, "Your name:", 0.25f, bottom, 0.75f, top);
  
  // имя
  greyRect(bottom -= 0.1f, top -= 0.1f);
  random_color().bright().select();
  const float width = 0.03f * name.size();
  drawString (GLUT_STROKE_ROMAN, name, 0.5f - width, bottom, 0.5f + width, top);
}


void EnterNameScreen::onChar(unsigned char code, int, int)
{
  switch (code)
  {
  case 27: glutLeaveMainLoop(); return;
  case '\n': case '\r': // продолжить
    doTransmitName(name); break;
  case '\b': // удалить последний символ
    name.resize(name.size() - 1); break;
  default: // добавить символ
    name.append(1u, (char)code);
  }
}
