﻿/*
 * This file is part of AV Orchid.
 * Copyright (c) 2013, Dmitri R. Kuvshinov <evetro.here@gmail.com>
 * 
 * Permission to use, copy, modify, and/or distribute this software for
 * any purpose with or without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all copies.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
/**
 * @file HallOfFameScreen.hpp
 *
 * Экран 1. Список лучших игроков.
 */
#pragma once
#include "DemoGameScreen.hpp"


/// экран "список лучших" + демо
class HallOfFameScreen : public DemoGameScreen
{
public:

  HallOfFameScreen();
  ~HallOfFameScreen() override;

  /// добавить в список игрока name, заработавшего score очков
  void addPlayer(Score score, const std::string &name);

  /// внешний обработчик события "игра начата"
  typedef std::function<void()> GameStartedHandler;
  /// привязать обработчик события "игра начата"
  void setGameStartedHandler(GameStartedHandler handler)
  {
    doGameStart = handler;
  }

protected:

  void onSelect() override;
  void onDisplay() override;
  void onChar(unsigned char code, int, int) override;

private:

  typedef DemoGameScreen Base;
  class HallOfFame *impl; // pimpl
  GameStartedHandler doGameStart;
};
